diff -ru openssh-3.7.1p1.orig/TODO openssh-3.7.1p1/TODO
--- openssh-3.7.1p1.orig/TODO	2003-06-11 23:56:41.000000000 +1000
+++ openssh-3.7.1p1/TODO	2003-09-18 09:38:40.000000000 +1000
@@ -30,8 +30,6 @@
 
 - More platforms for for setproctitle() emulation (testing needed)
 
-- Handle changing passwords for the non-PAM expired password case
-
 - Improve PAM support (a pam_lastlog module will cause sshd to exit)
   and maybe support alternate forms of authentications like OPIE via
   pam?
diff -ru openssh-3.7.1p1.orig/acconfig.h openssh-3.7.1p1/acconfig.h
--- openssh-3.7.1p1.orig/acconfig.h	2003-09-16 11:52:19.000000000 +1000
+++ openssh-3.7.1p1/acconfig.h	2003-09-18 09:38:40.000000000 +1000
@@ -59,6 +59,9 @@
 /* from environment and PATH */
 #undef LOGIN_PROGRAM_FALLBACK
 
+/* Path to passwd program */
+#undef PASSWD_PROGRAM_PATH
+
 /* Define if your password has a pw_class field */
 #undef HAVE_PW_CLASS_IN_PASSWD
 
diff -ru openssh-3.7.1p1.orig/auth-pam.c openssh-3.7.1p1/auth-pam.c
--- openssh-3.7.1p1.orig/auth-pam.c	2003-09-16 16:00:52.000000000 +1000
+++ openssh-3.7.1p1/auth-pam.c	2003-09-18 09:38:40.000000000 +1000
@@ -52,6 +52,7 @@
 #include "auth-options.h"
 
 extern ServerOptions options;
+extern int password_change_required;
 
 #define __unused
 
@@ -114,7 +115,6 @@
 static pam_handle_t *sshpam_handle;
 static int sshpam_err;
 static int sshpam_authenticated;
-static int sshpam_new_authtok_reqd;
 static int sshpam_session_open;
 static int sshpam_cred_established;
 
@@ -267,7 +267,7 @@
 		pam_close_session(sshpam_handle, PAM_SILENT);
 		sshpam_session_open = 0;
 	}
-	sshpam_authenticated = sshpam_new_authtok_reqd = 0;
+	sshpam_authenticated = password_change_required = 0;
 	pam_end(sshpam_handle, sshpam_err);
 	sshpam_handle = NULL;
 }
@@ -523,14 +523,8 @@
 	if (sshpam_err != PAM_SUCCESS && sshpam_err != PAM_NEW_AUTHTOK_REQD)
 		return (0);
 
-	if (sshpam_err == PAM_NEW_AUTHTOK_REQD) {
-		sshpam_new_authtok_reqd = 1;
-
-		/* Prevent forwardings until password changed */
-		no_port_forwarding_flag |= 2;
-		no_agent_forwarding_flag |= 2;
-		no_x11_forwarding_flag |= 2;
-	}
+	if (sshpam_err == PAM_NEW_AUTHTOK_REQD)
+		flag_password_change_required();
 
 	return (1);
 }
@@ -589,12 +583,6 @@
 		    pam_strerror(sshpam_handle, sshpam_err));
 }
 
-int
-is_pam_password_change_required(void)
-{
-	return (sshpam_new_authtok_reqd);
-}
-
 static int
 pam_chauthtok_conv(int n, const struct pam_message **msg,
     struct pam_response **resp, void *data)
@@ -661,6 +649,8 @@
 	if (sshpam_err != PAM_SUCCESS)
 		fatal("PAM: pam_chauthtok(): %s",
 		    pam_strerror(sshpam_handle, sshpam_err));
+	else
+		flag_password_change_successful();
 }
 
 /* 
diff -ru openssh-3.7.1p1.orig/auth-passwd.c openssh-3.7.1p1/auth-passwd.c
--- openssh-3.7.1p1.orig/auth-passwd.c	2003-09-13 10:41:56.000000000 +1000
+++ openssh-3.7.1p1/auth-passwd.c	2003-09-18 09:38:40.000000000 +1000
@@ -42,13 +42,17 @@
 #include "log.h"
 #include "servconf.h"
 #include "auth.h"
-#ifdef WITH_AIXAUTHENTICATE
-# include "buffer.h"
-# include "canohost.h"
-extern Buffer loginmsg;
-#endif
+#include "buffer.h"
+#include "canohost.h"
+#include "misc.h"
+#include "channels.h"
+#include "auth-options.h"
+#include "uidswap.h"
 
 extern ServerOptions options;
+extern Buffer loginmsg;
+
+int password_change_required = 0;
 
 /*
  * Tries to authenticate the user using password.  Returns true if
@@ -99,7 +103,6 @@
 
 		if (authenticate(pw->pw_name, password, &reenter,
 		    &authmsg) == 0 && ok) {
-			char *msg;
 			char *host = 
 			    (char *)get_canonical_hostname(options.use_dns);
 
@@ -107,19 +110,7 @@
 			aix_remove_embedded_newlines(authmsg);	
 
 			debug3("AIX/authenticate succeeded for user %s: %.100s",
-				pw->pw_name, authmsg);
-
-	        	/* No pty yet, so just label the line as "ssh" */
-			aix_setauthdb(authctxt->user);
-	        	if (loginsuccess(authctxt->user, host, "ssh", 
-			    &msg) == 0) {
-				if (msg != NULL) {
-					debug("%s: msg %s", __func__, msg);
-					buffer_append(&loginmsg, msg, 
-					    strlen(msg));
-					xfree(msg);
-				}
-			}
+			    pw->pw_name, authmsg);
 		} else {
 			debug3("AIX/authenticate failed for user %s: %.100s",
 			    pw->pw_name, authmsg);
@@ -161,3 +152,79 @@
 # endif
 #endif /* !HAVE_OSF_SIA */
 }
+
+/*
+ * Perform generic password change via tty. Like do_pam_chauthtok(),
+ * it throws a fatal error if the password can't be changed.
+ */
+int
+do_tty_change_password(struct passwd *pw)
+{
+	pid_t pid;
+	int status;
+	mysig_t old_signal;
+
+	old_signal = signal(SIGCHLD, SIG_DFL);
+
+	if ((pid = fork()) == -1)
+		fatal("Couldn't fork: %s", strerror(errno));
+
+	if (pid == 0) {
+		permanently_set_uid(pw);
+		if (geteuid() == 0) 
+			execl(PASSWD_PROGRAM_PATH, "passwd", pw->pw_name,
+			    (char *)NULL);
+		else
+			execl(PASSWD_PROGRAM_PATH, "passwd", (char *)NULL);
+			
+		/* execl shouldn't return */
+		fatal("Couldn't exec %s", PASSWD_PROGRAM_PATH);
+		exit(1);
+	}
+
+	debug3("%s: waiting for pid %d", __func__, (int)pid);
+	if (waitpid(pid, &status, 0) == -1)
+		fatal("Couldn't wait for child: %s", strerror(errno));
+	signal(SIGCHLD, old_signal);
+
+	if (WIFEXITED(status) && WEXITSTATUS(status) == 0) {
+		debug("%s password changed sucessfully", __func__);
+		flag_password_change_successful();
+		return 1;
+	} else {
+		fatal("Failed to change password for %s, passwd returned %d",
+		    pw->pw_name, status);
+		return 0;
+	}
+}
+
+/*
+ * flag that password change is necessary
+ */
+void
+flag_password_change_required(void)
+{
+	debug3("disabling forwarding");
+	password_change_required = 1;
+
+	/* disallow other functionality for now */
+	no_port_forwarding_flag |= 2;
+	no_agent_forwarding_flag |= 2;
+	no_x11_forwarding_flag |= 2;
+}
+
+/*
+ * password change successful
+ * XXX: must be done in parent, but currently there is no way to pass
+ * this request.
+ */
+void
+flag_password_change_successful(void)
+{
+	debug3("resetting forwarding flags");
+
+	password_change_required = 0;
+	no_port_forwarding_flag &= ~2;
+	no_agent_forwarding_flag &= ~2;
+	no_x11_forwarding_flag &= ~2;
+}
diff -ru openssh-3.7.1p1.orig/auth.c openssh-3.7.1p1/auth.c
--- openssh-3.7.1p1.orig/auth.c	2003-09-03 07:32:46.000000000 +1000
+++ openssh-3.7.1p1/auth.c	2003-09-18 09:38:40.000000000 +1000
@@ -36,6 +36,14 @@
 #include <libgen.h>
 #endif
 
+#ifdef WITH_AIXAUTHENTICATE
+#include <userpw.h>
+#include <usersec.h>
+# ifdef HAVE_SYS_AUDIT_H
+#  include <sys/audit.h>
+# endif
+#endif
+
 #include "xmalloc.h"
 #include "match.h"
 #include "groupaccess.h"
@@ -51,6 +59,7 @@
 #include "misc.h"
 #include "bufaux.h"
 #include "packet.h"
+#include "sshlogin.h"
 
 /* import */
 extern ServerOptions options;
@@ -59,6 +68,8 @@
 /* Debugging messages */
 Buffer auth_debug;
 int auth_debug_init;
+extern Buffer expiremsg;
+extern Buffer loginmsg;
 
 /*
  * Check if the user is allowed to log in via ssh. If user is listed
@@ -84,39 +95,67 @@
 	if (!pw || !pw->pw_name)
 		return 0;
 
+#define	DAY		(24L * 60 * 60) /* 1 day in seconds */
+#define WEEK		(DAY * 7)	/* 1 week in seconds */
 #if defined(HAVE_SHADOW_H) && !defined(DISABLE_SHADOW)
 	if (!options.use_pam)
 		spw = getspnam(pw->pw_name);
 #ifdef HAS_SHADOW_EXPIRE
-#define	DAY		(24L * 60 * 60) /* 1 day in seconds */
 	if (!options.use_pam && spw != NULL) {
 		time_t today;
+		int daysleft;
 
+	debug("%s: entering", __func__);
 		today = time(NULL) / DAY;
 		debug3("allowed_user: today %d sp_expire %d sp_lstchg %d"
-		    " sp_max %d", (int)today, (int)spw->sp_expire,
-		    (int)spw->sp_lstchg, (int)spw->sp_max);
+		    " sp_max %d sp_warn %d", (int)today, (int)spw->sp_expire,
+		    (int)spw->sp_lstchg, (int)spw->sp_max, (int)spw->sp_warn);
 
 		/*
 		 * We assume account and password expiration occurs the
 		 * day after the day specified.
 		 */
-		if (spw->sp_expire != -1 && today > spw->sp_expire) {
+		daysleft = spw->sp_expire - today;
+		if (spw->sp_expire == -1) {
+			debug3("account expiration disabled");
+		} else if (daysleft < 0) {
 			logit("Account %.100s has expired", pw->pw_name);
 			return 0;
+		} else if (daysleft <= spw->sp_warn) {
+			char buf[256];
+
+			debug3("account will expire in %d days", daysleft);
+			snprintf(buf, sizeof(buf),
+			    "Your account will expire in %d day%s.\n",
+			    daysleft, daysleft == 1 ? "" : "s");
+			buffer_append(&loginmsg, buf, strlen(buf));
 		}
 
+#define PWCHG_FORCED    "You must change your password now.\n"
+#define PWCHG_EXPIRED   "Your password has expired, you must change it now.\n"
+		daysleft = spw->sp_lstchg + spw->sp_max - today;
 		if (spw->sp_lstchg == 0) {
 			logit("User %.100s password has expired (root forced)",
 			    pw->pw_name);
-			return 0;
-		}
-
-		if (spw->sp_max != -1 &&
-		    today > spw->sp_lstchg + spw->sp_max) {
+			flag_password_change_required();
+			buffer_append(&expiremsg, PWCHG_FORCED,
+			    sizeof(PWCHG_FORCED));
+		} else if (spw->sp_max == -1) {
+			debug3("password expiration disabled");
+		} else if (daysleft < 0) {
 			logit("User %.100s password has expired (password aged)",
 			    pw->pw_name);
-			return 0;
+			flag_password_change_required();
+			buffer_append(&expiremsg, PWCHG_EXPIRED,
+			    sizeof(PWCHG_EXPIRED));
+		} else if (daysleft <= spw->sp_warn) {
+			char buf[256];
+
+			debug3("password will expire in %d days", daysleft);
+			snprintf(buf, sizeof(buf),
+			    "Your password will expire in %d day%s.\n",
+			    daysleft, daysleft == 1 ? "" : "s");
+			buffer_append(&expiremsg, buf, strlen(buf));
 		}
 	}
 #endif /* HAS_SHADOW_EXPIRE */
@@ -257,6 +296,64 @@
 				return 0;
 		}
 	}
+
+	/*
+	 * Check AIX password expiry.  Only check when running as root.
+	 * Unpriv'ed users can't access /etc/security/passwd or
+	 * /etc/security/user so passwdexpired will always fail.
+	 */
+	if (geteuid() == 0) {
+		char *msg, *user = pw->pw_name;
+		int result, maxage, result2, maxexpired;
+		struct userpw *upw;
+
+		/*
+		 * Check if password expired too long as in this case,
+		 * passwdexpired still returns 1 but /bin/passwd will fail
+		 */
+		upw = getuserpw(user);
+		result = getuserattr(user, S_MAXEXPIRED, &maxexpired, SEC_INT);
+		result2 = getuserattr(user, S_MAXAGE, &maxage, SEC_INT);
+		if (upw != NULL && result == 0 && result2 == 0) {
+			time_t now = time(NULL);
+
+			debug3("%s lastupdate %lu maxage %d wks maxexpired %d"
+			    "wks time now %d", __func__, 
+			    (unsigned long)upw->upw_lastupdate, maxage,
+			    maxexpired, now);
+
+			if (maxexpired != -1 && maxage != 0 &&
+			    upw->upw_lastupdate + ((maxage+maxexpired) * WEEK) <= now ) {
+				logit("User %.100s password expired too long",
+				    user);
+				return 0;
+			}
+		}
+
+		result = passwdexpired(user, &msg);
+		if (msg && *msg) {
+			buffer_append(&expiremsg, msg, strlen(msg));
+			aix_remove_embedded_newlines(msg);
+		}
+		debug3("AIX/passwdexpired returned %d msg %.100s", result, msg);
+
+		switch (result) {
+		case 0: /* success, password not expired */
+			break;
+		case 1: /* expired, password change required */
+			flag_password_change_required();
+			break;
+		default: /* user can't change(2) or other error (-1) */
+			logit("Password can't be changed for user %s: "
+			    "%.100s", user, msg);
+			if (msg)
+				xfree(msg);
+			return 0;
+		}
+		if (msg)
+			xfree(msg);
+
+	}
 #endif /* WITH_AIXAUTHENTICATE */
 
 	/* We found no reason not to let this user try to log on... */
@@ -271,6 +368,46 @@
 	return authctxt;
 }
 
+/*
+ * Generate last_login message and store for later display.  This must be
+ * called before login_login() is called and lastlog is updated.
+ */
+void
+generate_loginmsg(const char *user, uid_t uid, const char *host)
+{
+#ifdef WITH_AIXAUTHENTICATE
+	char *msg;
+
+	/* We don't have a pty yet, so just label the line as "ssh" */
+	aix_setauthdb(user);
+	if (loginsuccess(user, host, "ssh", &msg) >= 0)
+		buffer_append(&loginmsg, msg, strlen(msg));
+#elif !defined(NO_SSH_LASTLOG)
+	if (options.print_lastlog) {
+		char *time_string, lasthost[MAXHOSTNAMELEN], buf[256];
+		time_t last_login_time;
+
+		last_login_time = get_last_login_time(uid, user, lasthost,
+		   sizeof(lasthost));
+
+		if (last_login_time != 0) {
+		       time_string = ctime(&last_login_time);
+		       if (strchr(time_string, '\n'))
+			       *strchr(time_string, '\n') = 0;
+		       if (strcmp(lasthost, "") == 0)
+			       snprintf(buf, sizeof(buf),
+				   "Last login: %s\r\n",
+				   time_string);
+		       else
+			       snprintf(buf, sizeof(buf),
+				   "Last login: %s from %s\r\n",
+				   time_string, lasthost);
+		       buffer_append(&loginmsg, buf, strlen(buf));
+		}
+       }
+#endif
+}
+
 void
 auth_log(Authctxt *authctxt, int authenticated, char *method, char *info)
 {
@@ -298,6 +435,10 @@
 	    get_remote_port(),
 	    info);
 
+	if (authenticated && geteuid() == 0)
+		generate_loginmsg(authctxt->user, authctxt->pw->pw_uid,
+		    get_canonical_hostname(options.use_dns));
+
 #ifdef CUSTOM_FAILED_LOGIN
 	if (authenticated == 0 && strcmp(method, "password") == 0)
 		record_failed_login(authctxt->user, "ssh");
diff -ru openssh-3.7.1p1.orig/auth.h openssh-3.7.1p1/auth.h
--- openssh-3.7.1p1.orig/auth.h	2003-09-03 12:11:30.000000000 +1000
+++ openssh-3.7.1p1/auth.h	2003-09-18 09:38:40.000000000 +1000
@@ -144,6 +144,9 @@
 
 int	allowed_user(struct passwd *);
 struct passwd * getpwnamallow(const char *user);
+int	do_tty_change_password(struct passwd *pw);
+void	flag_password_change_required(void);
+void	flag_password_change_successful(void);
 
 char	*get_challenge(Authctxt *);
 int	verify_response(Authctxt *, const char *);
Only in openssh-3.7.1p1/: autom4te-2.53.cache
Only in openssh-3.7.1p1/: autom4te.cache
